/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import wssl.Constraint;

/**
 * Pruning evaluation for the exceptionally complex case
 * @author George
 */
public class ExtendedPREval2015 {
	
	public static int tasksize = 100;
	public static int implsize = 5;
	public static float prune_percent = (float) 1;			
    
    public static void main(String[] args) {

            
        Constraint[] goals = new Constraint[20];	
        goals[0] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task1");
        goals[1] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task2");
        goals[2] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task3");
        goals[3] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task4");
        goals[4] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task5");
        goals[5] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task6");
        goals[6] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task7");
        goals[7] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task8");
        goals[8] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task9");
        goals[9] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task10");
        goals[10] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task11");
        goals[11] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task12");
        goals[12] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task13");
        goals[13] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task14");
        goals[14] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task15");
        goals[15] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task16");
        goals[16] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task17");
        goals[17] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task18");
        goals[18] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task19");
        goals[19] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task20");
        
        
        String[] tasks = new String[]{"task1", "task2", "task3", "task4", "task5", "task6", "task7", "task8", "task9", "task10", "task11", "task12", "task13", "task14", "task15", "task16", "task17", "task18", "task19", "task20"};
        
        int impls[][] = new int[100][100];
        int impls2[][] = new int[100][100];
        String[] impls_str = null;
        int line_num = 0;
        
        try {
            BufferedReader in = new BufferedReader(new FileReader("d:\\impls.txt"));
            String str;
            //str = in.readLine();
            while ((str = in.readLine()) != null) {
            	
            	impls_str = str.split(",");
                for(int j=0;j<100;j++){
                	impls[line_num][j] = Integer.valueOf(impls_str[j]); 
                }
                line_num++;
            }
            in.close();
            /*line_num = 0;
            in = new BufferedReader(new FileReader("d:\\impls2.txt"));
            //str = in.readLine();
            while ((str = in.readLine()) != null) {
            	
            	impls_str = str.split(",");
                for(int j=0;j<100;j++){
                	impls2[line_num][j] = Integer.valueOf(impls_str[j]); 
                }
                line_num++;
            }
            in.close();*/
        } catch (IOException e) {
            System.out.println("File Read Error");
        }
        /*for(int i=0;i<100;i++){
        	for(int j=0;j<100;j++){
        		System.out.println(impls[i][j] + " ");
        	}
        }
        System.out.println(line_num);*/

        long startTime = System.currentTimeMillis();
    	long stopTime, elapsedTime=0;
        
        int plansret = PlanPruning(1000, goals, tasks, impls, impls2);
        stopTime = System.currentTimeMillis();
        elapsedTime = stopTime - startTime;
        		
        
        System.out.println(elapsedTime);
        System.out.println(plansret);
            
            
    }
    

    public static int PlanPruning(int plans, Constraint[] goals, String[] tasks, int[][] impls, int[][] impls2){
    	int plans_ret = plans;
    	int pruned = 0;
    	//int lin = 0;
    	for(int i=0;i<plans;i++){
    		outerloop:
    		for(int j=0;j<tasksize;j++){
    			for(int k=0;k<goals.length;k++){
    				if(goals[k].getServiceName().equals(tasks[j%20])){
    					//lin++;
    					int count=0;
    					for(int l=0;l<implsize;l++){
    						float val = (float) goals[k].getVal();
    						
    						if(val<impls[j][l]){
    							count++;
    						}
    					}
    					//count=implsize;
    					//System.out.println(count);
    					if(count==implsize-1){
    						plans_ret--;
    						pruned=1;
    						if(plans_ret==plans-prune_percent*plans){
    							//System.out.println("DDI");
    							impls = impls2;
    						}  					
    					}
    				}
    				if(pruned==1){
    					pruned=0;
    					break outerloop;
    				}
    			}
    		}
    	}
    	return plans_ret;
    	//return lin;
    	
    }
   
}