/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.overall;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvals2 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int start = 90;
        int size = 60;
        String url_w = "wssl/evaluation/overall/two.pl";
        try {
            Path outpath = null;
            try {
                outpath = Paths.get(new URI(def_location + url_w));
            } catch (URISyntaxException ex) {
                Logger.getLogger(CreateEvals2.class.getName()).log(Level.SEVERE, null, ex);
            }
            try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                String writeOut = "";
                for(int i=1;i<=size;i++){
                    writeOut += "poss(spec" + (start+i) + ", Z) :- holds(hasinput(io" + i + "), Z), holds(hasinput(io" + (i+1) + "), Z), holds(cond" + i + ", Z), holds(cond" + (i+1) + ", Z).\n";
                }
                for(int i=1;i<=size/2;i++){
                    writeOut += "state_update(Z, spec" + (start+i) + ", Z_PR) :- update(Z, [hasoutput(io" + (i+2) + "), hasoutput(io" + (i+3) + "), cond" + (i+2) + ", cond" + (i+3) + "], [hasinput(io" + i + "), hasinput(io" + (i+1) + ")], Z_PR).\n";
                }  
                for(int i=size/2 + 1;i<=size;i++){
                    writeOut += "state_update(Z, spec" + (start+i) + ", Z_PR) :- ramify(Z, [hasoutput(io" + (i+2) + "), hasoutput(io" + (i+3) + "), cond" + (i+2) + ", cond" + (i+3) + "], [hasinput(io" + i + "), hasinput(io" + (i+1) + ")], Z_PR).\n";
                }
                for(int i=size/2 + 1;i<=size;i++){
                    writeOut += "causes(Z, P, N, [hasinput(io" + (i+4) + "), cond" + (i+4) + "|Z], [hasinput(io" + (i+4) + "), cond" + (i+4) + "|P], N) :- P = [hasoutput(io" + (i+2) + "), hasoutput(io" + (i+3) + "), cond" + (i+2) + ", cond" + (i+3) + "], N = [hasinput(io" + i + "), hasinput(io" + (i+1) + ")].\n";
                }                
                //writeOut += "planner(Z, [], Z) :- holds(cond" + size[i] + "(p" + size[i] + "), Z).\n";
                //writeOut += "planner(Z, [A|P], Z_PR) :- poss(A, Z), state_update(Z, A, Z1), planner(Z1, P, Z_PR)";
                byte data[] = writeOut.getBytes();
                out.write(data, 0, data.length);
                out.flush();
            }
        } catch (IOException ex) {
                Logger.getLogger(CreateEvals2.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}