/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.planner;

import com.parctechnologies.eclipse.CompoundTerm;
import com.parctechnologies.eclipse.EclipseEngine;
import com.parctechnologies.eclipse.EclipseEngineOptions;
import com.parctechnologies.eclipse.EclipseException;
import com.parctechnologies.eclipse.EmbeddedEclipse;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;

import wssl.parser.DOMParser2;
import wssl.parser.InvalidFormatException;

/**
 *
 * @author George
 */
public class Planner {
    
    public static void main(String[] args) {
        try {
            URL def_location = Planner.class.getProtectionDomain().getCodeSource().getLocation();
            //System.out.println(def_location.getFile());
            //System.out.println(def_location);
            //String url = "wssl/validator/samplewssl.xml";            
            String url_w = "wssl/helpmeout3.pl";
            String url_f = "wssl/flux.pl";
            @SuppressWarnings("unused")
			DOMParser2 pr = new DOMParser2();

                // Create some default Eclipse options
            EclipseEngineOptions eclipseEngineOptions = new EclipseEngineOptions();
            //eclipseEngineOptions.setEclipseDir(new File("/C:/Program Files (x86)/ECLiPSe 6.1/"));
                // Object representing the Eclipse process
            EclipseEngine engine;

                // Connect the Eclipse's standard streams to the JVM's
            eclipseEngineOptions.setUseQueues(false);

                // Initialise Eclipse
            engine = EmbeddedEclipse.getInstance(eclipseEngineOptions);
            
            //FromEclipseQueue stdout = engine.getEclipseStdout();  //manual stream parsing
            //stdout.setListener(new OutputConsumer());
            
            engine.compile(new File(def_location.getFile() + url_f));
            engine.compile(new File(def_location.getFile() + url_w));

            System.out.print("Enter an ECLiPSe query and press Enter: ");
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
            String query = br.readLine();

            CompoundTerm res = engine.rpc(query);                //take only first goal for now                
            System.out.println(res.toString());
            System.exit(1);
            /*for(int i=0;i<pr.getSize();i++){
                System.out.println(pr.getVariable(i)+"\n");
            }*/

            
            

                // Destroy the Eclipse process
            ((EmbeddedEclipse) engine).destroy();
        } catch (InvalidFormatException | EclipseException | IOException ex) {
            String reason = ex.toString();
            /*if(reason.startsWith("com.parc")){
                reason = "ECLiPSe syntax error";
            }*/
            System.out.println(reason);
            //Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
        /**
     * Extracts the plans contained in a {@link CompoundTerm} result (returned from ECLiPSe)
     * and prunes plans that fail to meet local QoS requirements
     * @param result The {@link CompoundTerm} object that is returned after executing query
     * @return a {@link CompoundTerm} containing the plans that remain post pruning
     */
    public static CompoundTerm PlanPruning(CompoundTerm result){
        
        return null;
    }
}
