/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvalsMM {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        //int[] size = {1,2,10,20,50,100};
        int[] size = {5};
        for(int i=0;i<size.length;i++){
            String url_w = "wssl/evaluation/mm" + size[i] + ".pl";
            try {
                Path outpath = null;
                try {
                    outpath = Paths.get(new URI(def_location + url_w));
                } catch (URISyntaxException ex) {
                    Logger.getLogger(CreateEvalsMM.class.getName()).log(Level.SEVERE, null, ex);
                }
                try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                    String writeOut = "poss(s1(";
                    for(int j=0;j<size[i];j++){
                        writeOut += "P" + (j+1) + ", ";
                    }
                    writeOut += "_), Z) :- ";
                    for(int j=0;j<size[i];j++){
                        writeOut += "holds(hasinput(P" + (j+1) + "), Z), holds(cond" + (j+1) + "(P" + (j+1) + "), Z), ";
                    }
                    writeOut = writeOut.substring(0, writeOut.length()-2) + ".\r\nstate_update(Z, s1(";
                    for(int j=0;j<size[i];j++){
                        writeOut += "P" + (j+1) + ", P" +(j+1) + "B, "; 
                    }
                    writeOut = writeOut.substring(0, writeOut.length()-2) + "), Z_PR) :- update(Z, [";
                    for(int j=0;j<size[i];j++){
                        writeOut += "hasoutput(P" + (j+1) + "B), cond" + (j+1) + "B(P" + (j+1) + "B), ";
                    }
                    writeOut = writeOut.substring(0, writeOut.length()-2) + "], [";
                    for(int j=0;j<size[i];j++){
                        writeOut += "hasinput(P" + (j+1) + "), cond" + (j+1) + "(P" + (j+1) + "), ";
                    }                     
                    writeOut = writeOut.substring(0, writeOut.length()-2) + "], Z_PR).";
                    byte data[] = writeOut.getBytes();
                    out.write(data, 0, data.length);
                    out.flush();
                }
            } catch (IOException ex) {
                    Logger.getLogger(CreateEvalsMM.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}