/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.overall;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvalsFD1 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int size = 200;
        int match = 180;
        String url_w = "wssl/evaluation/overall/fd3.pl";
        try {
            Path outpath = null;
            try {
                outpath = Paths.get(new URI(def_location + url_w));
            } catch (URISyntaxException ex) {
                Logger.getLogger(CreateEvalsFD1.class.getName()).log(Level.SEVERE, null, ex);
            }
            try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                String writeOut = "";
                for(int i=1;i<=match;i++){
                    writeOut += "poss(spec" + i + ", Z) :- holds(hasinput(io1), Z), holds(hasinput(io2), Z), holds(cond1, Z), holds(cond2, Z).\n";
                }
                for(int i=match+1;i<=size;i++){
                	writeOut += "poss(spec" + i + ", Z) :- holds(hasinput(io5), Z), holds(hasinput(io6), Z), holds(cond1, Z), holds(cond2, Z).\n";
                }                
                for(int i=1;i<=size;i++){
                    writeOut += "state_update(Z, spec" + i + ", Z_PR) :- update(Z, [hasoutput(io3), hasoutput(io4), cond3, cond4], [hasinput(io1), hasinput(io2)], Z_PR).\n";
                }  
                //writeOut += "planner(Z, [], Z) :- holds(cond" + size[i] + "(p" + size[i] + "), Z).\n";
                //writeOut += "planner(Z, [A|P], Z_PR) :- poss(A, Z), state_update(Z, A, Z1), planner(Z1, P, Z_PR)";
                byte data[] = writeOut.getBytes();
                out.write(data, 0, data.length);
                out.flush();
            }
        } catch (IOException ex) {
                Logger.getLogger(CreateEvalsFD1.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}