/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.overall;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvalsFDNew {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int size = 200;
        int impls = 5;
        int searches = 3;
        //int match = 180;
        String url_w = "wssl/evaluation/overall/newfdcase5.pl";
        try {
            Path outpath = null;
            try {
                outpath = Paths.get(new URI(def_location + url_w));
            } catch (URISyntaxException ex) {
                Logger.getLogger(CreateEvalsFDNew.class.getName()).log(Level.SEVERE, null, ex);
            }
            try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                String writeOut = "";
                for(int k=0;k<impls;k++){
	                for(int j=0;j<size;j++){
	                    writeOut += "poss(spec" + (k*size+(j+1)) + ", Z) :- holds(hasinput(io" + (j+1) + "), Z), holds(cond" + (j+1) + ", Z).\n";
	                }
	            }
                for(int k=0;k<impls;k++){
	                for(int j=0;j<size;j++){
	                    writeOut += "state_update(Z, spec" + (k*size+(j+1)) + ", Z_PR) :- update(Z, [hasoutput(io" + (j+2) + "), cond" + (j+2) + "], [hasinput(io" + (j+1) + "), cond" + (j+1) + "], Z_PR).\n";
	                }
                }                
                /*for(int j=0;j<searches;j++){
                	writeOut += "init(Z" + (j+1) + "a) :- Z" + (j+1) + "a = [hasinput(io" + (size/2-searches+j) + "), cond" + (size/2-searches+j) + "].\n";
                	writeOut += "init(Z" + (j+1) + "b) :- Z" + (j+1) + "b = [cond" + (size/2-searches+j+1) + ", hasoutput(io" + (size/2-searches+j+1) + ")].\n";                	
                }*/
                writeOut += "match([";
                for(int j=0;j<searches;j++){
                	writeOut += "T" + (j+1) + ", ";
                }
                /*writeOut = writeOut.substring(0, writeOut.length()-2);
                writeOut += "], ["; 
                for(int j=0;j<searches;j++){
                	writeOut += "Z" + (j+1) + "a, ";
                } 
                writeOut = writeOut.substring(0, writeOut.length()-2);
                writeOut += "], [";     
                for(int j=0;j<searches;j++){
                	writeOut += "Z" + (j+1) + "b, ";
                } */
                writeOut = writeOut.substring(0, writeOut.length()-2);
                writeOut += "]) :-";
                for(int j=0;j<searches;j++){
                	//writeOut += "init(Z" + (j+1) + "a), init(Z" + (j+1) + "b), poss(T" + (j+1) + ", Z" + (j+1) + "a), state_update(Z" + (j+1) + "a, T" + (j+1) + ", Z" + (j+1) + "b), ";
                	writeOut += " poss(T" + (j+1) + ", [hasinput(io" + (size/2-searches+j) + "), cond" + (size/2-searches+j) + "]), state_update([hasinput(io" + (size/2-searches+j) + "), cond" + (size/2-searches+j) + "], T" + (j+1) + ", [cond" + (size/2-searches+j+1) + ", hasoutput(io" + (size/2-searches+j+1) + ")]), ";
                }
                writeOut = writeOut.substring(0, writeOut.length()-2);
                writeOut += ".\n";                

                byte data[] = writeOut.getBytes();
                out.write(data, 0, data.length);
                out.flush();
                
            }
        } catch (IOException ex) {
                Logger.getLogger(CreateEvalsFDNew.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}