/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.overall;


import wssl.Constraint;

/**
 * Realizes WSSL service composition, followed by abstract plan pruning and ranking
 * @author George
 */
public class ExtendedPR {
	
	public static int implsize = 5;
	public static int tasksize = 14;
	public static float success_rate = (float) 0.9;
			
    
    public static void main(String[] args) {
    	long startTime = System.currentTimeMillis();
    	long stopTime, elapsedTime=0;

            
        Constraint[] goals = new Constraint[5];	
        goals[0] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task1");
        goals[1] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task2");
        goals[2] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task3");
        goals[3] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task4");
        goals[4] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task5");
        
        String[] tasks = new String[]{"task1", "task2", "task3", "task4", "task5", "task6", "task7", "task8", "task9", "task10", "task11", "task12", "task13", "task14"};
        int[][] impls = new int[][]{{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30},{30,30,30,30,30}};
        int[][] impls2 = new int[][]{{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20},{20,20,20,20,20}};		
        		
        		
        		
        		  

        PlanPruning(2167, goals, tasks, impls, impls2);
        stopTime = System.currentTimeMillis();
        elapsedTime = stopTime - startTime;
        System.out.println(elapsedTime);
            
            
    }
    

    public static int PlanPruning(int plans, Constraint[] goals, String[] tasks, int[][] impls, int[][] impls2){
    	int plans_ret = plans;
    	int pruned = 0;
    	for(int i=0;i<plans;i++){
    		outerloop:
    		for(int j=0;j<tasksize;j++){
    			for(int k=0;k<goals.length;k++){
    				if(goals[k].getServiceName().equals(tasks[j])){
    					int count=0;
    					for(int l=0;l<implsize;l++){
    						float val = (float) goals[k].getVal();
    						if(!(impls[j][l] < val)){
    							count++;
    						}
    					}
    					//count=implsize;
    					if(count==implsize){
    						//System.out.println("PLANS_RET:"+plans_ret);
    						plans_ret--;
    						pruned=1;
    						if(plans_ret==plans - (Math.floor(success_rate*plans))){
    							impls = impls2;
    						}
    					}
    				}
    				if(pruned==1){
    					pruned=0;
    					break outerloop;
    				}
    			}
    		}
    	}
    	return plans_ret;
    	
    }
   
}
