/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.plannew;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvals3 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int[] size = {5,10,50,100,200,500,1000};
        //int[] size = {3,6,9,12,15,18,21,24,27,30};
        //int[] size = {2,4,5,7,8,9,10};
        //int[] size = {5};
        for(int i=0;i<size.length;i++){
            String url_w = "wssl/evaluation/newseqand" + size[i] + ".pl";
            try {
                Path outpath = null;
                try {
                    outpath = Paths.get(new URI(def_location + url_w));
                } catch (URISyntaxException ex) {
                    Logger.getLogger(CreateEvals3.class.getName()).log(Level.SEVERE, null, ex);
                }
                try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                    String writeOut = "";
                    int o = -1;
                    for(int j=0;j<size[i];j++){
                        if(j%3==0){
                            o++;
                            j += o;
                            writeOut += "poss(spec" + (j-o+1) + ", Z) :- holds(hasinput(io" + (j+1) + "), Z), holds(cond" + (j+1) + ", Z), holds(hasinput(io" + (j+2) + "), Z), holds(cond" + (j+2) + ", Z).\n";
                            j -= o;
                        }
                        else{
                            j += o;
                            writeOut += "poss(spec" + (j-o+1) + ", Z) :- holds(hasinput(io" + (j+2) + "), Z), holds(cond" + (j+2) + ", Z).\n";
                            j -= o;
                        }
                    }
                    o = -1;
                    for(int j=0;j<size[i];j++){
                        if(j%3==0){
                            o++;
                            j += o;
                            writeOut += "state_update(Z, spec" + (j-o+1) + ", Z_PR) :- update(Z, [hasoutput(io" + (j+3) + "), cond" + (j+3) + ", hasoutput(io" + (j+4) + "), cond" + (j+4) + "], [hasinput(io" + (j+1) + "), cond" + (j+1) + ", hasinput(io" + (j+2) + "), cond" + (j+2) + "], Z_PR).\n";
                            j -= o;
                        }
                        else{
                            j += o;
                            writeOut += "state_update(Z, spec" + (j-o+1) + ", Z_PR) :- update(Z, [hasoutput(io" + (j+4) + "), cond" + (j+4) + "], [hasinput(io" + (j+2) + "), cond" + (j+2) + "], Z_PR).\n";
                            j -= o;
                        }                        
                        
                    }
                    int a = size[i]/3;
                    writeOut += "planner(Z, [], Z) :- holds(cond" + (3*a+(a+1)) + ", Z), holds(cond" + (3*a+(a+2)) + ", Z), !.\n";
                    /*for(int j=0;j<size[i]-1;j++){
                        writeOut += "planner(Z, [A|P], Z_PR) :- A = and(A1, A2), A1 = s" + (j+1) + "(_, _), A2 = s" + (j+2) + "(_, _), poss_and(A1, A2, Z), state_update_and(Z, A1, A2, Z1), planner(Z1, P, Z_PR).\n";
                    }
                    writeOut += "planner(Z, [A|P], Z_PR) :- poss(A, Z), state_update(Z, A, Z1), planner(Z1, P, Z_PR).";*/
                    writeOut += "planner(Z, [A|P], Z_PR) :- A = and(A1, A2), poss_and(A1, A2, Z), state_update_and(Z, A1, A2, Z1), planner(Z1, P, Z_PR).\n";
                    writeOut += "planner(Z, [A|P], Z_PR) :- poss(A, Z), state_update(Z, A, Z1), planner(Z1, P, Z_PR).";
                    byte data[] = writeOut.getBytes();
                    out.write(data, 0, data.length);
                    out.flush();
                }
            } catch (IOException ex) {
                    Logger.getLogger(CreateEvals3.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}